<template>
  <div>
    <v-app-bar
      height="70px"
      color="white"
      fixed
      elevate-on-scroll
    >
      <v-toolbar-title>
        <v-btn
          rounded
          text
          href="/"
          class="font-weight-bold"
        >
          {{ $t('home') }}
          <v-icon>mdi-magnify</v-icon>
        </v-btn>
      </v-toolbar-title>

      <v-btn
        rounded
        text
        :href="$t('movici.url')"
        class="font-weight-bold"
      >
        {{ $t('movici.title') }}
      </v-btn>

      <v-btn
        rounded
        text
        :href="$t('toolbox.url')"
        class="font-weight-bold"
      >
        {{ $t('toolbox.title') }}
      </v-btn>

      <v-spacer />

      <MHeaderCommunities
        :user-id="user ? user.id : null"
        :text-color-class="'font-weight-bold'"
        :links-color-class="'black--text'"
      />


      <div v-if="user">
        <MHeaderProfile
          :avatar="user.avatars[0]"
          :short-family-name="(user.shortFamilyName) ? user.givenName+' '+user.shortFamilyName : '-'"
          :text-color-class="'font-weight-bold'"
          :links-color-class="'black--text'"
        />

        <v-tooltip bottom>
          <template v-slot:activator="{ on, attrs }">
            <a
              :href="$t('buttons.messages.route')"
            >
              <v-badge
                :value="unreadMessageNumber>0 ? true : false"
                color="secondary"
                :content="unreadMessageNumber"
                overlap
              >              
                <img
                  :src="$t('message')"
                  width="30px"
                  height="23px"
                  justify="center"
                  align="center"
                  class="mr-3"
                  v-bind="attrs"
                  v-on="on"
                >
              </v-badge>
            </a>
          </template>
          <span>{{ $t('tooltip.messages') }}</span>
        </v-tooltip>
      </div>
      <div
        v-else
      >
        <v-btn
          rounded
          text
          :href="$t('buttons.signup.route')"
          class="font-weight-bold mr-4"
        >
          {{ $t('buttons.signup.label') }}
        </v-btn>
        <v-btn
          rounded
          text
          :href="$t('buttons.logIn.route')"
          class="font-weight-bold mr-4"
        >
          {{ $t('buttons.logIn.label') }}
        </v-btn>
      </div>
      <v-btn
        rounded
        :disabled="!user"
        :href="$t('buttons.shareAnAd.route')"
        class="font-weight-bold elevation-0 ml-4"
        color="success"
      >
        {{ $t('buttons.shareAnAd.label') }}
      </v-btn>
      <MHeaderLanguage
        :languages="languages"
        :language="dlocale"
        @languageSelected="updateLanguage"
      />
    </v-app-bar>
    <GamificationNotifications :user-gamification-notifications="(user && user.gamificationNotifications) ? user.gamificationNotifications : null" />
    <GratuityNotifications :user-gratuity-notifications="(user && user.gratuityNotifications) ? user.gratuityNotifications : null" />
    <!-- legal guardian dialog -->
    <v-dialog
      v-if="user"
      v-model="activeLegalGuardianDialog"
      persistent
      max-width="900"
    >
      <v-card>
        <v-card-title
          class="text-h5 justify-center"
        >
          {{ $t('dialog.parentalConsent.title') }}
        </v-card-title>
        <v-card-text v-html="$t('dialog.parentalConsent.content',{'legalGuardianEmail':user.legalGuardianEmail})" />
        <v-card-actions>
          <v-spacer />
          <v-btn
            color="secondary"
            primary
            rounded
            :href="this.$t('buttons.logOut.route')"
          >
            {{ $t('dialog.parentalConsent.buttonLabel') }}
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import { merge, has } from "lodash";
import {messages_en, messages_fr, messages_eu} from "@translations/components/base/MHeader/";
import {messages_client_en, messages_client_fr, messages_client_eu} from "@clientTranslations/components/base/MHeader/";
import MHeaderProfile from "@components/base/MHeaderProfile.vue";
import MHeaderCommunities from "@components/base/MHeaderCommunities.vue";
import MHeaderLanguage from "@components/base/MHeaderLanguage.vue";
import GamificationNotifications from "@components/utilities/gamification/GamificationNotifications";
import GratuityNotifications from "@components/utilities/gratuity/GratuityNotifications";

let MessagesMergedEn = merge(messages_en, messages_client_en);
let MessagesMergedEu = merge(messages_eu, messages_client_eu);
let MessagesMergedFr = merge(messages_fr, messages_client_fr);

export default {
  i18n: {
    messages: {
      'en': MessagesMergedEn,
      'eu': MessagesMergedEu,
      'fr': MessagesMergedFr
    }
  },
  components: {
    MHeaderProfile,
    MHeaderCommunities,
    MHeaderLanguage,
    GamificationNotifications,
    GratuityNotifications
  },
  props: {
    user: {
      type: Object,
      default: null
    },
    locale: {
      type: String,
      default: "fr"
    },
    languages: {
      type: Object,
      default: () => {}
    },
    token: {
      type: String,
      default: ''
    },
    gamificationActive:{
      type: Boolean,
      default: false
    }
  },
  data () {
    return {
      imageLink: "/images/pages/header/",
      width: 0,
      snackbar: null,    
      fab: false,
      defaultLocale: 'fr',
      dlocale: this.locale,
      activeLegalGuardianDialog: false
    }
  },
  computed:{
    unreadMessageNumber(){
      return this.user.unreadCarpoolMessageNumber + this.user.unreadDirectMessageNumber + this.user.unreadSolidaryMessageNumber; 
    }
  },
  mounted() {
    if (has(this.languages, this.locale)) {
      this.dlocale = this.locale;
    } else {
      this.dlocale = this.defaultLocale;
    }
    this.$store.commit('g/setActive',this.gamificationActive);
    this.$store.commit('grt/setActive',this.gratuityActive);
  },
  created() {
    this.$store.commit('a/setToken',this.user?.token ? this.user.token : this.token);
    if(this.user){
      localStorage.setItem('X-LOCALE',this.dlocale);
    }
    if(this.user?.needParentalConsent) {
      this.activeLegalGuardianDialog = true;
    }
    this.$root.$i18n.locale = this.dlocale
  },
  methods:{
    updateLanguage(language) {
      this.$root.$i18n.locale = language
    },
  }
};
</script>
<style scoped lang="scss">
  * {
    font-family: $heading-font-family;
  }
  .v-toolbar__title{
    a{
      text-decoration:none;
    }
  }
</style>